<?php
	// ======================================== \
	// Package: Mihalism Multi Host
	// Version: 3.1.2
	// Copyright (c) 2007, 2008 Mihalism, Inc.
	// License: http://www.gnu.org/licenses/old-licenses/gpl-3.0.txt GNU Public License
	// ======================================== /
	
	if(!defined('IN_MMH')){
		exit;
	}

	ob_start(); 
	clearstatcache();

	header("Cache-Control: no-cache, must-revalidate"); 
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

	ini_set('display_errors'  , 0);
	ini_set('register_globals', 0); 
	ini_set('memory_limit'    , -1);
	ini_set('post_max_size'   , -1);

	$CONFIG            	      = array();
	$CONFIG['current_page']       = (($_GET['page'] != '') ? $_GET['page'] : 1);
	$CONFIG['cookie_expire_time'] = (time() + 31536000);
	$CONFIG['thumbnail_width']    = 152;
	$CONFIG['thumbnail_height']   = 130;
	$CONFIG['max_results']        = 20;
	$CONFIG['date_format']        = 'D F j, Y, g:i:s a';
	$CONFIG['in_acp']             = ((preg_match("/admin\.php/", $_SERVER['PHP_SELF'])) ? true : false);
	$CONFIG['file_path']          = 'files/';
	$CONFIG['version']            = '3.1.2'; 
	$CONFIG['php_version']        = explode(".", phpversion());
	$CONFIG['db_prefix']          = 'mmh_';
	$CONFIG['banned_email_list']  = array();
	$CONFIG['banned_user_list']   = array();
	$CONFIG['banned_ip_list']     = array();
	$CONFIG['query_limit_build']  = (($CONFIG['current_page'] * $CONFIG['max_results']) - $CONFIG['max_results']).", ".$CONFIG['max_results'];

	define('SQL_ADMIN_SESSIONS_TABLE' , $CONFIG['db_prefix'].'admin_sessions');
	define('SQL_BANNED_DATA_TABLE'    , $CONFIG['db_prefix'].'banned_data');
	define('SQL_FILE_LOGS_TABLE'      , $CONFIG['db_prefix'].'file_logs');
	define('SQL_FILE_STORAGE_TABLE'   , $CONFIG['db_prefix'].'file_storage');
	define('SQL_USERS_TABLE'          , $CONFIG['db_prefix'].'user_data');
	define('SQL_NEW_PASSWORDS_TABLE'  , $CONFIG['db_prefix'].'new_passwords');
	define('SQL_ROBOT_INFO_TABLE'     , $CONFIG['db_prefix'].'robot_info');
	define('SQL_ROBOT_LOG_TABLE'      , $CONFIG['db_prefix'].'robot_logs');
	define('SQL_SITE_SETTINGS_TABLE'  , $CONFIG['db_prefix'].'site_settings');
	define('SQL_COUNTRY_DATA_TABLE'   , $CONFIG['db_prefix'].'country_data');
	define('SQL_RATINGS_TABLE'        , $CONFIG['db_prefix'].'file_ratings');

	require_once(ROOT_PATH.'config.php'); 
	require_once(ROOT_PATH.'source/database_functions.php');
	require_once(ROOT_PATH.'source/global_functions.php');

	if(!version_compare(phpversion(), "4.0.0", ">=")){ 
		exit("Your PHP version is not comparable with mihalism multi host v{$CONFIG['version']}. You need to be running PHP4 or greater but instead you are running PHP".(($CONFIG['php_version']['0'] != '') ? $CONFIG['php_version']['0'] : phpversion()).". Until this problem is fixed you will not be able to use mihalism multi host v{$CONFIG['version']}.");
	}elseif(!extension_loaded('mysql')){
		exit("Sorry but mihalism multi host v{$CONFIG['version']} will not work without MySQL loaded as a PHP extension. Until this problem is fixed you will not be able to use mihalism multi host v{$CONFIG['version']}.");
	}elseif(!extension_loaded("gd2") && !extension_loaded("gd")){
		exit("Sorry but mihalism multi host v{$CONFIG['version']} will not work without GD Library loaded as a PHP extension. Until this problem is fixed you will not be able to use mihalism multi host v{$CONFIG['version']}.");
	}

	if(empty($CONFIG['site_installed'])){
		if(!preg_match("/install\.php/", $_SERVER['PHP_SELF'])){
			header('Location: '.ROOT_PATH.'install.php');
			exit;
		}else{
			$CONFIG['site_name'] = "Mihalism Multi Host v{$CONFIG['version']} Installer";
		}
	}

	$DB = new host_database();
	$DB->sql_connect($CONFIG['sql_host'], $CONFIG['sql_user'], $CONFIG['sql_password'], $CONFIG['sql_database']);

	$DB->query("SELECT * FROM `".SQL_SITE_SETTINGS_TABLE."`");
	while($row = $DB->fetch_row()){
		if($row['option'] == 'file_types' || $row['option'] == 'user_file_types'){
			$CONFIG[$row['option']] = preg_split("/,/", preg_replace("/\./", "", $row['value']));
		}else{
			$CONFIG[$row['option']] = $row['value'];
		}
	}

	if($_COOKIE['mmh_user_cookie'] != ''){
		$cookie_data = explode(".", $_COOKIE['mmh_user_cookie']);
		$DB->query("SELECT * FROM `".SQL_USERS_TABLE."` WHERE `user_name` = '".$cookie_data['0']."' AND `user_session` = '".$cookie_data['1']."'");
		if($DB->get_num_rows() == 1){
			$CONFIG['is_user'] = true;
		}
	}

	if($CONFIG['is_user'] == true){
		$UDATA = $DB->fetch_row($DB->query("SELECT * FROM `".SQL_USERS_TABLE."` WHERE `user_session` = '".$cookie_data['1']."'"));
	}

	if($_COOKIE['mmh_admin_cookie'] != ''){
		$DB->query("SELECT * FROM `".SQL_ADMIN_SESSIONS_TABLE."` WHERE `session` = '".$_COOKIE['mmh_admin_cookie']."'");
		$row = $DB->fetch_row();
		if($DB->get_num_rows() > 0){
			if($UDATA['user_id'] == $row['admin_id']){
				if(preg_match("/ADMIN/i", $UDATA['group'])){
					$CONFIG['is_admin'] = true;
				}
			}
		}
	}

	if($CONFIG['is_user'] == true){
		$CONFIG['guest_max_size']   = $CONFIG['max_file_size'];
		$CONFIG['guest_file_types'] = $CONFIG['file_types'];
		unset($CONFIG['max_file_size']);
		unset($CONFIG['file_types']);
		$CONFIG['max_file_size'] = $CONFIG['user_max_file_size']; 
		$CONFIG['file_types']    = $CONFIG['user_file_types']; 
		unset($CONFIG['user_max_file_size']);
		unset($CONFIG['user_file_types']);
	}

	if($CONFIG['in_acp'] == true && $CONFIG['is_admin'] == true){
		$sql = $DB->query("SELECT * FROM `".SQL_ADMIN_SESSIONS_TABLE."`");
		while($row = $DB->fetch_row($sql)){
			if($row['admin_id'] == $UDATA['user_id']){
				if($row['session'] != $_COOKIE['mmh_admin_cookie']){
					$DB->query("DELETE FROM `".SQL_ADMIN_SESSIONS_TABLE."` WHERE `session` = '".$row['session']."'");
				}
			}
		}
	}

	$CONFIG['site_url'] = get_url(false, false, false);
	$CONFIG['page_url'] = get_url(true, false, true);

	$sql = $DB->query("SELECT * FROM `".SQL_ROBOT_INFO_TABLE."`");
	while($row = $DB->fetch_row($sql)){
		if(preg_match("/".str_replace("/", "\/", $row['robot_match'])."/", $_SERVER['HTTP_USER_AGENT'])){
			$DB->query("INSERT INTO `".SQL_ROBOT_LOG_TABLE."` VALUES('".$row['robot_id']."', '".time()."', '".$CONFIG['page_url']."')");
		}
	}

	$DB->query("SELECT * FROM `".SQL_BANNED_DATA_TABLE."`");
	while($row = $DB->fetch_row()){
		if($row['user_name'] != ''){
			$CONFIG['banned_user_list'][] = $row['user_name'];
		}
		if($row['ip_address'] != ''){
			$CONFIG['banned_ip_list'][] = $row['ip_address'];
		}
		if($row['email_address'] != ''){
			$CONFIG['banned_email_list'][] = $row['email_address'];
		}
	}


	if($CONFIG['is_user'] && in_array($UDATA['user_name'], $CONFIG['banned_user_list'])){
		if(!preg_match("/act\=(show_banned|logout|contact_us|contact_us_go)/i", $CONFIG['page_url'])){
			header('Location: ./users.php?act=show_banned');
			exit;
		}
	}

	if(in_array($_SERVER['REMOTE_ADDR'], $CONFIG['banned_ip_list'])){
		if(!preg_match("/act\=show_banned/i", $CONFIG['page_url'])){
			header('Location: ./users.php?act=show_banned');
			exit;
		}
	}

	if(!$CONFIG['is_admin'] && $CONFIG['in_acp'] && !preg_match("/act\=(login|login_go)/i", $CONFIG['page_url'])){
		header('Location: ./admin.php?act=login');
		exit;
	}

	if($_GET['do_random'] == 'true'){
		random_image();
	}

	$btnc = (($CONFIG['button_set'] == 1) ? 'blue' : 'yellow');
	$BUTTON = array(
			'save'            => 'css/BTN_'.$btnc.'_SaveChanges.png',
			'cancel'          => 'css/BTN_'.$btnc.'_Cancel.png',
			'start_uploading' => 'css/BTN_'.$btnc.'_StartUploading.png',
			'add_files'       => 'css/BTN_'.$btnc.'_AddMoreFiles.png',
			'delete'          => 'css/BTN_'.$btnc.'_Delete.png',
			'send'            => 'css/BTN_'.$btnc.'_Send.png',
			'done'            => 'css/BTN_'.$btnc.'_Done.png',
			'login'           => 'css/BTN_'.$btnc.'_Login.png',
			'clear'           => 'css/BTN_'.$btnc.'_Clear.png',
			'register'        => 'css/BTN_'.$btnc.'_Register.png',
			'go_to_image'     => 'css/BTN_GoToImage.png'
			);
?>
